#include <avr\io.h>

#define LCD_DATA    PORTD
#define LCD_CTR		PORTB
#define LCD_E 		3
#define LCD_RS 		4

#define F_CPU        4000000
#define CYCLES_PER_US ((F_CPU+500000)/1000000) 	/* cpu cycles per microsecond */


void delay(int us) 
{
    int delay_loops;
    register int  i;

    delay_loops = (us+3)/5*CYCLES_PER_US; 

	
    for (i=0; i < delay_loops; i++) {};
} 


void delayms(int ms)
{
	int i;
	for (i=0;i<ms;i++)
		delay(1000);

}



void init_LCD(void)
{

delayms(20);             // Wait 20ms
cbi(LCD_CTR,LCD_E);
cbi(LCD_CTR,LCD_RS);


LCD_DATA = (LCD_DATA&0x0F)|0x30;
sbi(LCD_CTR,LCD_E); cbi(LCD_CTR,LCD_E);
delayms(5);              // Wait 5ms

sbi(LCD_CTR,LCD_E); cbi(LCD_CTR,LCD_E);
delayms(5);              // Wait 5ms

sbi(LCD_CTR,LCD_E); cbi(LCD_CTR,LCD_E);
delayms(5);              // Wait 5ms


LCD_DATA = (LCD_DATA&0x0F)|0x20;
sbi(LCD_CTR,LCD_E); cbi(LCD_CTR,LCD_E);
delayms(4);              // Wait 5ms



LCD_DATA = (LCD_DATA&0x0F)|0x20;
sbi(LCD_CTR,LCD_E); cbi(LCD_CTR,LCD_E);
LCD_DATA = (LCD_DATA&0x0F)|0x80;
sbi(LCD_CTR,LCD_E); cbi(LCD_CTR,LCD_E);
delayms(4);              // Wait 5ms

LCD_DATA = (LCD_DATA&0x0F)|0x00;
sbi(LCD_CTR,LCD_E); cbi(LCD_CTR,LCD_E);
LCD_DATA = (LCD_DATA&0x0F)|0xC0;

sbi(LCD_CTR,LCD_E); cbi(LCD_CTR,LCD_E);
delayms(5);              // Wait 5ms


LCD_DATA = (LCD_DATA&0x0F)|0x00;
sbi(LCD_CTR,LCD_E); cbi(LCD_CTR,LCD_E);
LCD_DATA = (LCD_DATA&0x0F)|0x10;
sbi(LCD_CTR,LCD_E); cbi(LCD_CTR,LCD_E);
delayms(5);              // Wait 5ms


LCD_DATA = (LCD_DATA&0x0F)|0x00;
sbi(LCD_CTR,LCD_E); cbi(LCD_CTR,LCD_E);
LCD_DATA = (LCD_DATA&0x0F)|0x60;
sbi(LCD_CTR,LCD_E); cbi(LCD_CTR,LCD_E);
delayms(5);              // Wait 5ms

return;
}

void gotoxy(unsigned char x,unsigned char y)
{

cbi(LCD_CTR,LCD_RS);

LCD_DATA = (LCD_DATA&0x0F)|(((64*(y+1))+(x-1))&0xF0);
sbi(LCD_CTR,LCD_E); cbi(LCD_CTR,LCD_E);
&0xF0);
LCD_DATA = (LCD_DATA&0x0F)|((((64*(y+1))+(x-1))<<4)&0xF0);
sbi(LCD_CTR,LCD_E); cbi(LCD_CTR,LCD_E);

delayms(4);
return;
}









void clrscr(void)
{
 
cbi(LCD_CTR,LCD_RS);


LCD_DATA = (LCD_DATA&0x0F)|0x00;
sbi(LCD_CTR,LCD_E); cbi(LCD_CTR,LCD_E);


LCD_DATA = (LCD_DATA&0x0F)|0x10;
sbi(LCD_CTR,LCD_E); cbi(LCD_CTR,LCD_E);

delayms(5);                      // Wait 4.1ms
return;
}





void LCD_putchar(unsigned char value)
{

sbi(LCD_CTR,LCD_RS);


LCD_DATA = (LCD_DATA&0x0F)|(value&0xF0);
sbi(LCD_CTR,LCD_E); cbi(LCD_CTR,LCD_E);
LCD_DATA = (LCD_DATA&0x0F)|((value<<4)&0xF0);
sbi(LCD_CTR,LCD_E); cbi(LCD_CTR,LCD_E);
delayms(4);                       // Wait 400s

return;
}

void LCD_printxy(unsigned char x,unsigned char y, unsigned char *text)
{

gotoxy(x,y);            // Set cursor position

while( *text )          // while not end of text
  {
  LCD_putchar(*text++); // Write character and increment position
  } 

return;
}







int main (void)
 {
  init_LCD();
  clrscr();
  gotoxy(9,1);
  LCD_putchar('S');
  LCD_printxy(1,1,"Hellow world");
  
  LCD_printxy(9,2,"Teated Ok");
  
  
  while(1);

 }
 
 
 